from ctypes import *
import usb._objfinalizer as _objfinalizer
import usb.libloader
from _typeshed import Incomplete
from collections.abc import Generator

class _usb_endpoint_desc(Structure): ...
class _usb_interface_desc(Structure): ...
class _usb_config_desc(Structure): ...
class _usb_device_desc(Structure): ...
class _openusb_request_result(Structure): ...

class _openusb_ctrl_request(Structure):
    payload: Incomplete
    length: int
    timeout: int
    flags: int
    next: Incomplete
    def __init__(self) -> None: ...

    class _openusb_ctrl_setup(Structure): ...

class _openusb_intr_request(Structure): ...
class _openusb_bulk_request(Structure): ...

class _openusb_isoc_pkts(Structure):
    class _openusb_isoc_packet(Structure): ...

class _openusb_isoc_request(Structure): ...

class _Context(_objfinalizer.AutoFinalizedObject):
    handle: Incomplete
    def __init__(self) -> None: ...

class _BusIterator(_objfinalizer.AutoFinalizedObject):
    buslist: Incomplete
    num_busids: Incomplete
    def __init__(self) -> None: ...
    def __iter__(self): ...

class _DevIterator(_objfinalizer.AutoFinalizedObject):
    devlist: Incomplete
    num_devids: Incomplete
    def __init__(self, busid) -> None: ...
    def __iter__(self): ...

class _OpenUSB(usb.backend.IBackend):
    def enumerate_devices(self) -> Generator[Incomplete, None, None]: ...
    def get_device_descriptor(self, dev): ...
    def get_configuration_descriptor(self, dev, config): ...
    def get_interface_descriptor(self, dev, intf, alt, config): ...
    def get_endpoint_descriptor(self, dev, ep, intf, alt, config): ...
    def open_device(self, dev): ...
    def close_device(self, dev_handle) -> None: ...
    def set_configuration(self, dev_handle, config_value) -> None: ...
    def get_configuration(self, dev_handle): ...
    def set_interface_altsetting(self, dev_handle, intf, altsetting) -> None: ...
    def claim_interface(self, dev_handle, intf) -> None: ...
    def release_interface(self, dev_handle, intf) -> None: ...
    def bulk_write(self, dev_handle, ep, intf, data, timeout): ...
    def bulk_read(self, dev_handle, ep, intf, buff, timeout): ...
    def intr_write(self, dev_handle, ep, intf, data, timeout): ...
    def intr_read(self, dev_handle, ep, intf, buff, timeout): ...
    def ctrl_transfer(
        self, dev_handle, bmRequestType, bRequest, wValue, wIndex, data, timeout
    ): ...
    def reset_device(self, dev_handle) -> None: ...
    def clear_halt(self, dev_handle, ep) -> None: ...

# Names in __all__ with no definition:
#   get_backendOPENUSB_SUCCESSOPENUSB_PLATFORM_FAILUREOPENUSB_NO_RESOURCESOPENUSB_NO_BANDWIDTHOPENUSB_NOT_SUPPORTEDOPENUSB_HC_HARDWARE_ERROROPENUSB_INVALID_PERMOPENUSB_BUSYOPENUSB_BADARGOPENUSB_NOACCESSOPENUSB_PARSE_ERROROPENUSB_UNKNOWN_DEVICEOPENUSB_INVALID_HANDLEOPENUSB_SYS_FUNC_FAILUREOPENUSB_NULL_LISTOPENUSB_CB_CONTINUEOPENUSB_CB_TERMINATEOPENUSB_IO_STALLOPENUSB_IO_CRC_ERROROPENUSB_IO_DEVICE_HUNGOPENUSB_IO_REQ_TOO_BIGOPENUSB_IO_BIT_STUFFINGOPENUSB_IO_UNEXPECTED_PIDOPENUSB_IO_DATA_OVERRUNOPENUSB_IO_DATA_UNDERRUNOPENUSB_IO_BUFFER_OVERRUNOPENUSB_IO_BUFFER_UNDERRUNOPENUSB_IO_PID_CHECK_FAILUREOPENUSB_IO_DATA_TOGGLE_MISMATCHOPENUSB_IO_TIMEOUTOPENUSB_IO_CANCELED
